import ddf.minim.*;      //import library
Minim minim;             //minim library
AudioPlayer player;      //for audio file


float xBall = 250.0; 
float yBall = 250.0;

float x = 0;
float y = 0;

float speedX;
float speedY;

float velocityX = 1.0;
float velocityY = 1.0;

int dia = 10;

float timeInSeconds = millis()/1000;
long lastMillis=0;
int interval = 1150;

//--------------------------------------------

void setup(){
  size(500,500);
  background(0);
  smooth();
  frameRate(15);
  
  minim = new Minim (this);                    //create audio toolkit
  player = minim.loadFile ("MsJohnSoda.mp3");  //load file
  player.play();                               //play file

}

void draw(){
    
  blinkingBall();
  
  if(millis() > 17700){
    fill(0,0.1);
    rect(0,0,width,height);
    movingBall();
  }
  float timeInSeconds = millis()/1000;
  
  if(millis() > 82300){
    if(timeInSeconds % 1 == 0){
      translate(random(0,405),random(0,405));
      variableIvyLeave(x,y);
      if(millis() > 124000){
        fill(0,255,0,60);
      }
    }
  }
}

//--------------------------------------------

void blinkingBall(){
  fill(0,25);
  rect(0,0,width,height);
   if(millis() > 17000){
      fill(0,0.5);
    }
 
  if(millis() - lastMillis > interval){
    lastMillis=millis();
    fill(155);
    noStroke();
    ellipse(width/2,height/2,10,10);
  }
}

//----------

void movingBall(){
  speedX = random(-3, 5);
  speedY = random(-5, 5);

  if ((xBall > (width - dia/2)) || (xBall < (0 + dia/2))) {
    
    speedX = abs(speedX);
    velocityX = -velocityX;
  }
  if ((yBall > (height - dia/2)) || (yBall < (0 + dia/2))) {
  
    speedY = abs(speedY);
    velocityY = -velocityY;
  }

  xBall += speedX * velocityX;
  yBall += speedY * velocityY;

  fill(255);
  noStroke();
  ellipse(xBall, yBall, dia, dia);
}
  
//----------  

void ivyLeave(){
  stroke(55);
  strokeWeight(0.25);  
  fill(250,60);
  
  //triangle large
  triangle(50,120, 100,40, 150,120);
  
  //triangle small left
  pushMatrix();
  rotate(150);
  translate(-62,20);
  triangle(15,130, 40,70, 65,130);
  popMatrix();
  
  //triangle small right
  pushMatrix();
  rotate(-150);
  translate(125,-125);
  triangle(15,130, 40,70, 65,130);
  popMatrix();

}

//----------

void variableIvyLeave(float x, float y){
  pushMatrix();
  translate(x,y);
  x += random(1,9);
  y += random(1,11);
  ivyLeave();
  popMatrix();
}

